import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;

public class BluredBarMeter extends BarMeter {

    protected BufferedImage filteredImage;
    protected ConvolveOp blur;

    public void createBufferImage(){
        // Avbg̃TCY
        Dimension size = this.getSize();

        height = size.height;
        width = size.width;

        float[] blurElements = new float[25];
        for(int i = 0 ; i < 25 ; i++){
            blurElements[i] = 1.0f/25.0f;
        }

        Kernel kernel = new Kernel(5, 5, blurElements);
        blur = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);

        // C[W̐
        if(width != 0 && height != 0){
            image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
            filteredImage = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);

            graphics = image.getGraphics();
        }
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        if(image == null || resizeFlag){
            createBufferImage();
            resizeFlag = false;
        }

        // wiFœhԂ
        graphics.setColor(this.getBackground());
        graphics.fillRect(0, 0, width, height);

        // o[̕`
        drawBar(graphics, value);

        // Java2D ̃OtBbNReLXgɕϊ
        Graphics2D g2 = (Graphics2D)g;
        
        blur.filter((BufferedImage)image, filteredImage);

        // C[Wobt@̕`
        g2.drawImage(filteredImage, 0 , 0, this);
    }
}
